/**************************************************\
* Copyright 2011:                                  *
* William McGuire                                  *
* pantsless@waronpants.net                         *
* http://waronpants.net                            *
*                                                  *
* Originally posted at:                            *
* http://waronpants.net/p/419                      *
*                                                  *
* Use at your own risk                             *
\**************************************************/

/**************************************************\
*                   Change Log                     *
****************************************************
*                                                  *
* April 28, 2011 - v1.1                            *
* Multiple files can be processed in one execution *
* Fixed newline conversion error                   *
*                                                  *
* March 18, 2011 - v1.0                            *
* Original version                                 *
*                                                  *
\**************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

int main (int argc, char * argv [])
{
	if (argc < 2)
    {
        printf("Error: Must include at least one input file.\n");
        return -1;
    }
    
    int file_index;
    for (file_index = 1; file_index < argc; ++file_index)
    {
        FILE * infile = fopen(argv[file_index], "rb");
        
        if (! infile)
        {
            printf("Can't open input file: %s\n", argv[file_index]);
            return -1;
        }
        
        char * outfilename = (char *)malloc(strlen(argv[file_index]) + 10);
        sprintf(outfilename, "%s-char.txt", argv[file_index]);
        FILE * outfile = fopen(outfilename, "wb");
        
        if (! outfile)
        {
            printf("Can't open output file: %s\n", outfilename);
                free(outfilename);
            fclose(infile);
            return -1;
        }
        
        int bindigit;
        int num_digits = 0;
        unsigned char outchar = 0;
        while ( (bindigit = fgetc(infile)) != EOF )
        {
            switch ((char)bindigit)
            {
            case '0':
                //outchar &= ~(1<<(7-num_digits));
                break;
            case '1':
                outchar |= 1<<(7-num_digits);
                break;
            default:
                continue;
            }
            
            ++num_digits;
            
            if (num_digits > 7)
            {
                num_digits = 0;
                fprintf(outfile, "%c", outchar);
                outchar = 0;
            }
        }
        
        free(outfilename);
        fclose(infile);
        fclose(outfile);
    }
}
